
#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "Config.h"
#include "readflo.h"
#include "assert.h"

#include <io.h>
#include "..\suport.h"


extern int server_flag;
extern int client_flag;


RF_RULE *rf_rules = 0;

/*
 * Reads a line from a flo to dst[MAXPATHLEN], sets action
 * 1 -- ok
 * 0 -- EOF
 */
int read_flo_line (char *dst, int *action, FILE *flo)
{
  char buf[MAXPATHLEN + 1];
  int i;

  while (1)
  {
    if (!fgets (buf, MAXPATHLEN, flo))
      return 0;

    for (i = strlen (buf) - 1; i > 0 && isspace (buf[i]); --i)
      buf[i] = 0;

    switch (*buf)
      {
	case 0:
	case '~':
	  continue;
	case '^':
	  *action = 'd';
	  strcpy (dst, buf + 1);
	  break;
	case '#':
	  *action = 't';
	  strcpy (dst, buf + 1);
	  break;
	default:
	  *action = 0;
	  strcpy (dst, buf);
	  break;
      }
    break;
  }
  return 1;
}

/*
 * Translates a flo line using rf_rules.
 * Returns 0 if no rf_rules defined, otherwise returned value
 * should be free()'d
 */
char *trans_flo_line (char *s)
{
  RF_RULE *curr;
  char buf[MAXPATHLEN + 1];

  if (rf_rules)
  {
    char *w;

    strnzcpy (buf, s, MAXPATHLEN);
    for (curr = rf_rules; curr; curr = curr->next)
    {
      w = ed (buf, curr->from, curr->to, NULL);
      strnzcpy (buf, w, MAXPATHLEN);
      free (w);
    }
    return (char*) xstrdup (buf);
  }
  else
    return 0;
}

/*
 * Add a translation rule for trans_flo_line ()
 * (From and to are saved as pointers!)
 */
void rf_rule_add (char *from, char *to)
{
  static RF_RULE *last_rule = 0;
  RF_RULE *new_rule = (struct _RF_RULE *) xalloc (sizeof (RF_RULE));

  memset (new_rule, 0, sizeof (RF_RULE));
  new_rule->from = from;
  new_rule->to = to;
  if (last_rule)
    last_rule->next = new_rule;
  else
    rf_rules = new_rule;
  last_rule = new_rule;
}


void make_dlo_file (char *namefile,char* inbound)
{
		long hfile;
		_finddata_t se;
        FILE *fp;
		char param[500];
		char nfile[500];
		char par1[500];
		char par2[500];
		char netnode[13];
		int zone,net,node,point;
		
		if (server_flag && (dlg.m_dlo.GetCheck()==0)) return;
		if (client_flag && (dlg.m_dlo2.GetCheck()==0)) return;
		
		split_address(myaka,&zone,&net,&node,&point);
		 
		strcpy(nfile,inbound);
		strcat(nfile,"\\");
		strcat(nfile,namefile);
        fp=fopen(nfile,"wt"); 

		strcpy(param,inbound);
		strcat(param,"\\*.*");
		hfile = _findfirst(param,&se);
		if (hfile != -1L)
		{
		do
		{ 
		if (ispkt(se.name) || isarcmail(se.name) || istic(se.name))
		{ strcpy(par1,inbound);
		  strcat(par1,"\\");
		  strcat(par1,se.name);
          fprintf(fp,"%s \n",par1);
		}
		if (pmatch("*.[Rr][Ee][Qq]",se.name))
		{
		  strcpy(par1,inbound);
		  strcat(par1,"\\");
		  strcat(par1,se.name);
          strcpy(par2,inbound);
		  strcat(par2,"\\");
		  sprintf(netnode,"%0.4X%0.4X.REQ",net,node);
		  strcat(par2,netnode);
		  CopyFile(par1,par2,NULL);
		  
		  
		
		}
		
		}
		while (_findnext(hfile,&se)==0);
		_findclose(hfile);
		}
		//Netmail
		strcpy(param,inbound);
		strcat(param,"\\NETMAIL\\*.*");
		hfile = _findfirst(param,&se);
		if (hfile != -1L)
		{
		do
		{
		if (ispkt(se.name) || isarcmail(se.name) || istic(se.name)) 
		{
		  strcpy(par1,inbound);
		  strcat(par1,"\\NETMAIL\\");
		  strcat(par1,se.name);
          fprintf(fp,"%s \n",par1);
		}
        }
		while (_findnext(hfile,&se)==0);
		_findclose(hfile);
		}
	fclose(fp);	
    return ;
}
